Bug#405239: libgnutls13: gnutls13 has an unnecessary dependency on libgpg-error

Andreas Metzler ametzler at downhill.at.eu.org
Sun Jun 14 09:16:19 UTC 2009

On 2009-06-13 Kurt Roeckx <kurt at roeckx.be> wrote:
> On Sat, Jun 13, 2009 at 06:27:59PM +0200, Simon Josefsson wrote:
>> Kurt Roeckx <kurt at roeckx.be> writes:

>>> reassign 405239 libgnutls26
>> gnutls26's link problem is not caused by a convenience library.  It is
>> caused by direct linking, and I tried to provide a self-contained
>> explanation in
>> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=405239#39

> Is that with a Debian version of libtool, or with the upstream
> version?  Did you try with the current version in
> testing/unstable?  The Debian version has been patched for a long
> time not to add that depedency, except in that case of convience
> libraries.

Recent versions of gnutls indeed are not using Debian libtool anymore.
When using Debian's patched libtool some unnecessary linkage is
removed, but libgpg-error stays. However afaict the problem used to be
masked by a libtool problem, but currently is not a libtool problem
anymore. The culprit seems to be that this test

  AC_LIB_HAVE_LINKFLAGS(gcrypt,, [#include <gcrypt.h>],
    [enum gcry_cipher_algos i = GCRY_CIPHER_CAMELLIA128])
  if test "$ac_cv_libgcrypt" != yes; then
*** libgcrypt was not found. You may want to get it from
*** ftp://ftp.gnupg.org/gcrypt/libgcrypt/
gives us "checking how to link with libgcrypt... /usr/lib/libgcrypt.so
/usr/lib/libgpg-error.so", since AC_LIB_HAVE_LINKFLAGS recursively
expands la files. We therefore end up with 

/bin/bash ./libtool --tag=CC   --mode=link cc  [...] gnutls_psk_netconf.lo gl/liblgnu.la x509/libgnutls_x509.la -L/usr/lib -lz -L/usr/lib -lgcrypt -L/usr/lib -lgpg-error   openpgp/libgnutls_openpgp.la opencdk/libminiopencdk.la  

So libtool is not *adding* something.

Sorry Simon, I did not see this before.

cu andreas
`What a good friend you are to him, Dr. Maturin. His other friends are
so grateful to you.'
`I sew his ears on from time to time, sure'

More information about the Pkg-gnutls-maint mailing list